package zero1hd.polyjet.ui.stages;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.utils.viewport.FitViewport;

import zero1hd.polyjet.Polyjet;
import zero1hd.polyjet.controls.KeyMap;
import zero1hd.polyjet.entity.PolyJetEntity;


public class GamePlayArea extends Stage {
	public PolyJetEntity polyJet;
	
	private float health = 50;
	private float maxHealth = 100;
	private float yTeleport = Polyjet.GAME_AREA_HEIGHT/2;
	private int score;
	
	Texture basicLaserTexture;
	public GamePlayArea(Polyjet core) {
		super(new FitViewport(Polyjet.GAME_AREA_WIDTH, Polyjet.GAME_AREA_HEIGHT));
		
		polyJet = new PolyJetEntity(core, 48f, "standard");
		addActor(polyJet);
	}
	
	public void init() {
		health = 50;
		maxHealth = 100;
	}
	@Override
	public void act(float delta) {
		health -= 2*delta;
		
		if (health <= 0) {
			health = 0;
		}
		
		if (polyJet.getX() <= 1) {
			polyJet.moveLeft = false;
			polyJet.setX(1f);
		}
		
		if (polyJet.getX() >= Polyjet.GAME_AREA_WIDTH-1-polyJet.getWidth()) {
			polyJet.moveRight = false;
			polyJet.setX(Polyjet.GAME_AREA_WIDTH-1f-polyJet.getWidth());
		}
		
		if (polyJet.getY() >= Polyjet.GAME_AREA_HEIGHT - 1 - polyJet.getHeight()) {
			polyJet.moveUp = false;
			polyJet.setY(Polyjet.GAME_AREA_HEIGHT - 1 - polyJet.getHeight());
		}
		
		if (polyJet.getY() <= 1) {
			polyJet.moveDown = false;
			polyJet.setY(1f);
		}
		super.act(delta);
	}
	
	public void addScore (int score) {
		this.score += score;
		health += score;
		if (health > maxHealth) {
			health = maxHealth;
		}
	}

	@Override
	public boolean keyDown(int keycode) {
		if (keycode == KeyMap.left) {
			polyJet.moveLeft = true;
		}
		if (keycode == KeyMap.right) {
			polyJet.moveRight = true;
		}
		
		if (keycode == KeyMap.up) {
			polyJet.moveUp = true;
		}
		
		if (keycode == KeyMap.down) {
			polyJet.moveDown = true;
		}
		return false;
	}
	
	@Override
	public boolean keyUp(int keycode) {
		if (keycode == KeyMap.left) {
			polyJet.moveLeft = false;
		}
		if (keycode == KeyMap.right) {
			polyJet.moveRight = false;
		}
		if (keycode == KeyMap.up) {
			polyJet.moveUp = false;
		}
		if (keycode == KeyMap.down) {
			polyJet.moveDown = false;
		}
		if (keycode == KeyMap.shoot) {
		}
		return false;
	}

	public int getScore() {
		return score;
	}
	
	public float getHealth() {
		return health;
	}
	
	public float getMaxHealth() {
		return maxHealth;
	}
	public float getyTeleport() {
		return yTeleport;
	}
}
